#!/bin/bash 
ARCH=Linux86
GOA=/share/apps/goa-6.1.2
GOA_VAR=/share/apps/goa-var

GPS_HOME_DIR=/share/apps/cwu

PERL5LIB=$PERL5LIB:$GPS_HOME_DIR/perl_lib
PYTHONPATH=$PYTHONPATH:$GOA/lib/python

PATH=$GOA/bin:$GOA/bin/$ARCH:$GPS_HOME_DIR/bin:$PATH

cd /share/data
/share/apps/cwu/bin/get_orbits.pl -date `/bin/date -d "yesterday" "+%Y-%m-%d"` -type rapid -ac jgp
# Although the final orbits are produced every 14 days, one can often get them every 13 days
LASTWEEK=`/bin/date -d "-13day" "+%Y-%m-%d"`
/share/apps/cwu/bin/get_orbits.pl -date $LASTWEEK -type final -ac jgp

if [ $? -eq 1 ]
then
echo "No final orbits for $LASTWEEK yet, using 'at' to retry tomorrow"
at -m now + 1 days <<< "/share/apps/cwu/bin/get_orbits.pl -date $LASTWEEK -type final -ac jgp"
fi
