#!/usr/bin/env python

import argparse
import datetime
import pbo_process

def main(args):
    project = 'pbo-rapid'
    ac = 'jgp'
    orb = 'rapid'
    if (args.date):
        startDate = datetime.datetime.strptime(args.date,"%Y-%m-%d")
    else:
        startDate = datetime.datetime.today() - datetime.timedelta(days=1)
    args = argparse.Namespace(date=startDate,
            proj=project,
            ac=ac,
            orb=orb,
            snet=None,
            ndays=1,
            local=False,
            upload=True,
            update=False,
            amb=False,
            wlpb=True,
            address=['pbo-rapid@geology.cwu.edu'])
    pbo_process.main(args)

if __name__ == "__main__":
    import argparse
    import logging.config

    parser = argparse.ArgumentParser(description="PBO Daily processing script")
    parser.add_argument('--date','-d',help='Date to process')

    args = parser.parse_args()
    format = "%(asctime)s- %(name)s - %(levelname)s - %(message)s "
    logging.config.dictConfig({
        'version': 1,
        'disable_existing_loggers': False,
        'formatters': {
            'standard': {
                'format': format
            },
         },
         'handlers': {
             'file': {
                 'level': 'DEBUG',
                 'class': 'logging.handlers.RotatingFileHandler',
                 'filename': '/var/log/pbo/pbo-daily.log',
                 'formatter': 'standard',
                 'maxBytes': 5242880,
                 'backupCount': 5
             }
         },
         'loggers': {
             '': {
                 'handlers': ['file'],
                 'level': 'DEBUG',
                 'propagate': True
             }
         }
    })
    main(args)
