#!/usr/bin/env python

import env
from email.mime.text import MIMEText
import smtplib
import subprocess

def summary(project,date,ac,amb):
    """
    Generate a summary
    """
    gipsyEnvironment = env.readEnvironmentFile("/share/apps/cwu/etc/defaults")

    args = ['/share/apps/cwu/bin/summary','-proj',project,'-date',date,'-ac',ac,
            '-fields','rms','-rfields','dpos,chi,rms','-nmax','20']
    if (amb):
        args.append('-amb')
    p = subprocess.Popen(args,env=gipsyEnvironment,stdout=subprocess.PIPE)
    (stdout,stderr) = p.communicate()

    return stdout

def mail_summary(project,date,amb,body,addressList):
    """
    Email the summary to someone
    """
    server = smtplib.SMTP('localhost')
    sender = 'gnet@geology.cwu.edu'
    # If the address list consists of one email address
    # convert it to a list
    if (type(addressList) is str):
        addressList = [addressList]
    level = 'PPP'
    if (amb):
        level = 'AMB'
    # Construct the message
    message = MIMEText(body)
    message['Subject'] = "[Processing]: %s %s DONE: %s" % (project,level,date)
    message['From'] = sender
    message['To'] = ','.join(addressList)

    # Send the message
    server.sendmail(sender,addressList,message.as_string())
    server.quit()

if __name__ == "__main__":
    message = summary('pbo-reanalysis','1996-01-01','jgp',False)
    mail_summary('pbo-reanalysis','1996-01-01',False,message,'walter@geology.cwu.edu')

