package GOA::Util;
use Carp;
use Exporter;

@ISA=('Exporter');
@EXPORT = qw/ slurp
              head
              trim
              escape
              unescape
              rm_comment
	          spack
            /; 


#borrowed from CPAN's Slurp
sub slurp {
  local ( $/ , @ARGV ) = ( wantarray ? $/ : undef, @_ );
  return <ARGV>
}

sub head {
   my $f=shift;
   my $n = shift || 10;
   open(my $fh,'<',$f) or die "Couldn't open $f $!\n";
   my @h;
   while( <$fh> ) {
      push @h,$_;
      last if $. == $n;
   }
   return @h
}

sub escape {
   my $s = shift;
   $s =~ s/([^a-zA-Z0-9_ ])/\\$1/g;
   return $s
}	    
sub unescape {
   my $s = shift;
   $s =~ s/\\//g;
   return $s
}
sub trim2 {
    my @out = @_ ? @_ : $_;
    $_ = join(' ', split(' ')) for @out;
    return wantarray ? @out : "@out";
}    
sub rm_comment {
   my $s = shift;
   my %opt = (
     start_comment => '#',
     @_,
   );
   $opt{start_comment}=escape($opt{start_comment});
   $s =~ s/$opt{start_comment}.*//;
   return $s
}

sub spack {
   my %opt = (
      null => ' ',
      @_,
   );
   my $null = $opt{null};
   delete $opt{null};
   my $fmt = shift; 
   my $s = pack($fmt,@_);
   $s=~ s/\0/$null/g; 
   return $s 
}

sub trim {
   my $s = shift;
   $s =~ s/^\s+// ;
   $s =~ s/\s+$// ;
   return $s;
}

1;
