package GPS::AntennaGra;
use GPS::Defaults;
use GOA::Util;
my %par = get_defaults();

sub new {
  my $class = shift;
  my $file = shift || "$par{IGS_INFO_DIR}/antenna.gra";
  my $self = { file => $file } ;
  bless $self, $class;
  return $self->load;
}

sub file {
  my $self = shift;
  return $self->{file}
}

sub load {
  my $self = shift;
  my $file = $self->file;
  open(my $fh, '<', $file ) or die "Coulnd't open $file $!\n";
  my ( $arp,$arp_abbr,$ant_code,$ant_gra,$antenna_type);
  my $begin = 0;
  my $readable = 0;
  $self->{antenna_gra}=[ { antenna_type => [], ascii_diagram => '' } ];
  while ( <$fh> ) {
	 if ( /Machine-readable/i ) {
	    $readable=1;
		$begin=0;
	 }
	 elsif ( /^Abbreviations/i ) {
	     while ( my $line = readline($fh) ) {
            if ( $line =~ /^Dimensions/i  ) {
			  $line = readline($fh);
			  $line = readline($fh);
			  last;
			}
            chomp $line;
			$line =trim($line);
			next unless length($line);
			next if $line =~ /^-+/;
			($arp,$arp_abbr) = split(/\s*:\s*/,$line),
            $self->{arp_acronym}{$arp}=$arp_abbr;
		 }
		 $begin = 1;
         next;
	 }
	 elsif ( /^[A-Z0-9]{2}[A-Z0-9-]/ && $begin ) {
	    chomp;
  	    $antenna_type = trim($_);   
	    if ( ! @{$self->{antenna_gra}[-1]{antenna_type}} ) {
            push @{ $self->{antenna_gra}[-1]{antenna_type} },$antenna_type;
		}
		elsif ( $self->{antenna_gra}[-1]{ascii_diagram} ne ''   ) {
           
		   my $h= { antenna_type    => [ $antenna_type ] ,
			        ascii_diagram   => '' };
		   
		   push @{$self->{antenna_gra}},$h;

		}
	    elsif (  $self->{antenna_gra}[-1]{ascii_diagram} eq '' ) {
            push @{ $self->{antenna_gra}[-1]{antenna_type} },$antenna_type;
		}
	 }
     elsif ( /\s+([A-Z]{3})=ARP/ ) {
       $self->{antenna_arp}{$antenna_type}=$1; 
     }
	 elsif ( $readable && /^[A-Z0-9]{2}[A-Z0-9-]/ ) {
        $begin=0;
		chomp;
        next unless length(trim($_));
	    ($ant_code,$arp) = split(' ',$_);
		$self->{antenna_arp}{$ant_code}=$arp;
	 }
	 elsif ( $begin )  {
	   $self->{antenna_gra}[-1]{ascii_diagram}.=$_;
	 }
     

  }
  return $self
}

sub arp_acronym {
  my $self = shift;
  my $arp  = shift || '';
  if ( $arp ) {
    if ( exists $self->{arp_acronym} ) {
      return $self->{arp_acronym}{$arp};
    }
    else {
      warn "ARP:|$arp| doesn't exists \n";
      return '';
    }
  }
  else {
    return wantarray ? keys %{$self->{arp_acronym}} : $self->{arp_acronym}
  }
}

sub antenna_arp {
  my $self = shift;
  my $ant  = shift || '';
  if ( $ant ) {
    if ( exists $self->{antenna_arp} ) {
      return $self->{antenna_arp}{$ant};
    }
    else {
      warn "Antenna:|$ant| doesn't exists \n";
      return '';
    }
  }
  else {
    return wantarray ? keys %{$self->{antenna_arp}} : $self->{antenna_arp}
  }
}

1;
