package GPS::Coords;
use base GPS::DataTable;

#our @fields = qw/name lon lat net type /;
our @fields  = qw/name lon lat region 
                  type id16char tectonic_group
                  status orig_network location 
                 /;
#our $coords = "$ENV{GPS_HOME_DIR}/config/pbo/pbo_coords_public.txt";
#our $coords = "pbo_coords.dat";
sub new {
  my $class = shift;
  my $self = {};
  my %opt = (
      file => '',
      fields_in => join(',',@fields),
#      fmt  => "a4,2x,f9.4,2x,f9.4,2x,a7,2x,a",
      fmt  => "A4,2(2X,F9.4),2X,A9,1X,A10,1X,A16,1X,A11,1X,A16,1X,A10,1X,A",
      @_,
  );
  $opt{file}="$opt{dir}/$opt{file}" if ! $opt{file};
  
  bless $self,$class;

  return $self->init(%opt)
  
}

sub print {
   my $self = shift;
   my %opt = (
      build => 1,
      @_,
   ); 
   
   #$self->build() if $opt{build};
   $self->SUPER::print(%opt);
   
}

sub build {
   my $self = shift;
   
  $self->sort( field => 'name' ); 
  my %seen;
  my @sta = sort  grep { ! $seen{$_}++ }
                  map  { uc $_->{name} } @{$self->{data}};
  my $data = []; 
  foreach my $s ( @sta ) {
     my $entries = $self->select( name => $s );
     push @$data,$$entries[0];     
  }
  $self->{data} = $data;

}





