package GPS::Defaults;
use Exporter;
use Carp;
@ISA=('Exporter');
@EXPORT =( get_defaults, set_sta_info_dir ); 

our $gps_home_dir = $ENV{GPS_HOME_DIR} || "/share/apps/cwu";
our $dir  ="$gps_home_dir/etc";
our $file ="$gps_home_dir/etc/defaults";

sub get_defaults {
  my %opt = (
     file =>  $file,
     abs_pc => 1,
     rel_pc => 0,
     env  => {},
     @_, 
  );
  my %out=();
  my $defaults = "$opt{file}";
  open(DEF,"< $defaults") or croak "can't open $defaults \n" ;
  while ( <DEF> ) {
      chomp;
      s/#.*$//g;
      s/^\s+//g;
      s/\s+$//g;
      next unless length;
	  s/\$USER/$ENV{USER}/;
      next if /\`/;
      s/\"//g;
      s/\;//g;
      s/\$//g;
      my ($k,$v);
      if ( /set / ) {
        s/set\s+//;
        ($k,$v) = split(/\s*=\s*/,$_);
      }else{
        s/setenv\s+//;
        s/export\s*//;
        ($k,$v) = split(/=/,$_);
        $opt{env}{$k} = $v;
      }
      foreach my $l ( keys %out ) {
        $v =~ s/$l/$out{$l}/g  if $v =~ /$l/;
        $opt{env}{$k} = $v;
      }
      $out{$k} = $v;
  }

  if ( $opt{rel_pc} ) {
      %out=set_sta_info_dir( $out{STA_INFO_DIR_REL}, $opt{env},%out);
  }
  return %out
}

sub set_sta_info_dir {
  my $dir      = shift;
  my $env      = shift;
  my %par = @_;
  croak "Station info dir: $dir, doesn't exists \n" if ! -d $dir;
  $par{STA_INFO_DIR} = $dir;
  $par{STA_SVEC} = "$dir/sta_svec";
  $par{STA_POS} = "$dir/sta_pos";
  $par{STA_ID} = "$dir/sta_id";
  $par{PCENTER} = "$dir/pcenter";
  $par{PCMAPS}  = "$dir/phase_center_maps/by_antenna_type";
  $env->{STA_SVEC} = $par{STA_SVEC};
  $env->{STA_POS} = $par{STA_POS};
  $env->{STA_ID} = $par{STA_ID};
  $env->{PCENTER} = $par{PCENTER};
  $env->{PCMAPS} = $par{PCMAPS};
  return %par
}

1;
