package GPS::NetSites;

sub new {
  my $class = shift;
  my $self = { };
  bless $self,$class;
  return $self->load(@_);
}
sub load {
  my $self = shift;
  my %opt = ( proj => '',
              net  => '',
              @_,
             );
  my $proj= $opt{proj};
  my $net = uc $opt{net};
  my $pdir = "$ENV{GPS_HOME_DIR}/etc/proj_lists";
  if ( ! -e "$pdir/${proj}_net_sites" ) {
    warn "$proj doesn't exists in $pdir\n$usage";
    return undef;
  }

  open( my $fh,"$pdir/${proj}_net_sites") or die "couldn't open $pdir/${proj}_net_sites  $!\n";
  my @nets;
  while (<$fh> ) {
   chomp;
   s/#.*$//;
   s/^\s.*$//;
   next unless length;
   my @sta = split ' ',$_;
   my $snet = shift @sta;
   push @{$self->{$snet}},@sta;
  }
  return $self
}


#if ( $net && ! @sites ) { die "No sites for net $net\n Nets:@nets\n"; }

sub sites {
  my $self = shift;
  my @nets = @_ ?  @_ : $self->nets;
  my %seen =();
  my @sites=();
  
  foreach my $n ( sort @nets ) {
    push @sites,@{$self->{uc $n}};
  }
  
  @sites = sort grep { ! $seen{$_}++ } @sites;
  
  return wantarray ? @sites : \@sites
}

sub site_net {
  my $self=shift;
  my %sn=();
  my $s;
  foreach my $n ( $self->nets ) {
     foreach my $s ( $self->sites($n) ) {
        $sn{$s}=$n;
     }
  }
  return wantarray ? %sn : \%sn
}

sub nets {
  my $self = shift;
  my @nets = sort keys %$self ;
  return wantarray ? @nets : \@nets;
}

sub net_sites {
  my $self = shift;
  my %ns = %{$self};
  return wantarray ? %ns : \%ns;
}

1;

