package GPS::RcvrAnt;
use GOA::Util;

our %goa_vendor_name = ( 
                      '3S' =>  '3S Navigation Inc.',
                       AC  =>  'Antcom Corporation',
                       AA  =>  'Aeroantenna Technology Inc.',
                       AO  =>  'ITT  Allen Osborne Associates / ROGUE / AOA ',
                       AP  =>  'Altus Positioning System',
                       AS  =>  'Ashtech',
                       BL  =>  'GPS Satellite System, USA',
                       CM  =>  'Canadian Marconi ALLSTAR',
                       CT  =>  'ComNav Technology Ltd',
                       DG  =>  'DataGrid International',
                       ES  =>  'European Space Agency',
                       GA  =>  'Galileo Satellite System, European Union',
                       GL  =>  'GLONASS Satellite System, Russia',
                       GM  =>  'Generic Vendor/Maker',
                       GT  =>  'Geotracer',
                       GP  =>  'Geo++',
                       GU  =>  'Gutec AB',
                       HE  =>  'Hemisphere GPS',
                       HG  =>  'HighGain Technology Co. Ltd.',
                       JD  =>  'Javad GNSS Inc.',
                       JN  =>  'Javad Navigation Systems Inc.',
                       JP  =>  'ROGUE',
                       JS  =>  'JAVAD',
                       LC  =>  'Leica Geosystems',
                       MM  =>  'Minimac / Macrometer',
                       MG  =>  'Magellan',
                       MP  =>  'MicroPulse',
                       NC  =>  'NavCom',
                       NG  =>  'AOA D/M NGS',
                       NN  =>  'No Vendor/Maker',
                       NV  =>  'NovATel',
                       NX  =>  'navXperience',
                       PX  =>  'Prexiso',
                       RG  =>  'RUSNAVGEOSET',
                       QZ  =>  'QZSS Quasi-Zenith Satellite System, Japan',
                       RO  =>  'Rockwell',
                       SA  =>  'Satellite Antenna',
                       SL  =>  'Satlab GeoSolutions AB',
                       SP  =>  'Spectra Precision',
                       SS  =>  'Sensor Systems',
                       ST  =>  'Septentrio',
                       SK  =>  'Sokkia',
                       SX  =>  'Stonex',
                       TA  =>  'TI Asahi',
                       TN  =>  'Thales Navigation',
                       TI  =>  'Texas Inst.',
                       TP  =>  'Topcon Positioning Systems',
                       TR  =>  'Trimble',
                       TW  =>  'Tallysman Wireless Inc.',
);

our %vendor = ( '3SNAVIGATION'      => '3S',
                ASHTECH             => 'AS',
		CHAMPION            => 'CH',
		CHCNAVIGATION       => 'CN',
		COMNAVTECH          => 'CT',
                DOMES               => 'GM',
                HIGHGAIN            => 'HG',
		HARXON              => 'HX',
		HITARGET            => 'HI',
		HORIZON             => 'HZ',
		ITT                 => 'AO',
                IFEN                => 'IF',
                JAVAD               => 'JD',
                KOLIDA              => 'KO',
                LEICA               => 'LC',
                MAGELLAN            => 'MG',
                MICROPULSE          => 'MP',
                MINIMAC             => 'MM',
                NAVCOM              => 'NC', 
                NOVATEL             => 'NV',
                NAVXPERIENCE        => 'NX',
                PREXISO             => 'PX',
                OTHER               => 'GM',
                ROGUE               => 'AO',
                'ROGUE/AOA'         => 'A0',
                RUSNAVGEOSET        => 'RG',
                SATELLITE           => 'SA',
                SATLAB              => 'SL',
                'SENSOR SYST.'      => 'SS',
                SEPTENTRIO          => 'ST',     
                SOKKIA              => 'SK',
		SOUTH               => 'SO',
                SPECTRA             => 'SP',
                'SPECTRA PRECISION' => 'SP',
                'STONEX'            => 'SX',
                'TEXAS INST.'       => 'TI',
                'TI ASAHI'          => 'TA',
                TOPCON              => 'TP',
                TRIMBLE             => 'TR',
                TALLYSMAN           => 'TW',
            );

our %goa_vendor = ( 
                  '3S-' => '3S',  # 3SNAVIGATION
                  '3SN' => '3S',  # 3SNAVIGATION
                   ACC  => 'AC',  # Antcom Corporation (NGS)
                   AER  => 'AA',  # OTHER / Aeroantenna
                   AOA  => 'AO',  # ROGUE  ,
                   APS  => 'AP',  # ALTUS positioning system
                   ASH  => 'AS',  # ASHTECH  ,
                   BLO  => 'BL',
                   CMC  => 'CM',  # CANADIAN MARCONI ALLSTAR
                   CHA  => 'CH',  # Champion Instruments
                   CHC  => 'CN',  # CHC Navigation
                   CNT  => 'CT',  # ComNav Technology Ltd.
                   ESA  => 'ES',  # ESA / U. Leeds
                   DGR  => 'DG',  # DataGrid International (NGS)
                   GAL  => 'GA',  # Galileo Satellite
                   GLO  => 'GL',  # GLONASS Satellite
                   GPP  => 'GP',  # OTHER / Geo++
                   GEO  => 'SP',  # SPECTRA PRECISION Geotracer 
                   GUT  => 'GU',  # Gutec AB (NGS)
                   HEM  => 'HE',  # Hemisphere (NGS)
		   HGG  => 'HG',  # HighGain Information Technology Co. Ltd.
		   HIT  => 'HI',  # Hi-Target
		   HRZ  => 'HZ',  # Horizon
		   HXC  => 'HX',  # Harxon
                   IFN  => 'IF',  # IFEN
		   ITT  => 'AO',  # ITT  Allen Osborne Associates / ROGUE / AOA
                   JAV  => 'JD',  # JAVAD  ,
                   JNS  => 'JD',  # JAVAD  ,
                   JPL  => 'JP',  # ROGUE  ,
                   JPS  => 'JD',  # JAVAD  ,
		   KOL  => 'KL',  # KOLIDA
                   LEI  => 'LC',  # LEICA  ,
                   MAC  => 'MM',  # MINIMAC / MACROMETER
                   MIN  => 'MM',  # MINIMAC / MACROMETER
                   MAG  => 'MG',  # MAGELLAN  ,
                   MPL  => 'MP',  # MICROPULSE  ,
                  'MP-' => 'MP',  # MICROPULSE  ,
                   NAV  => 'NC',  # NAVCOM  ,
                   NAX  => 'NX',  # NAVXPERIENCE
                   NGS  => 'NG',  # AOA D/M NGS
                   NON  => 'NN',  # No Vendor/Maker
                   NOV  => 'NV',  # NOVATEL  ,
                   PRX  => 'PX',  # Prexiso
                   RNG  => 'RG',  # RUSNAVGEOSET
                   QZS  => 'QZ',  # QZSS 
                   ROC  => 'RO',  # ROCKWELL
                   ROG  => 'AO',  # ROGUE  ,
                   SEN  => 'SS',  # SENSOR SYST.  ,
                   SEP  => 'ST',  # SEPTENTRIO (NGS)
                   SLG  => 'SL',  # Satlab GeoSolutions AB
                   SMI  => 'AA',  # Aeroantenna
                   SOK  => 'SK',  # SOKKIA  ,
                   SPP  => 'SP',  # SPECTRA PRECISION         ,
		   STH  => 'SO',  # SOUTH
                   STX  => 'SX',  # STONEX
                   THA  => 'TN',  # THALES NAVIGATION
                   TIA  => 'TA',  # TI ASASHI
                   TI4  => 'TI',  # TEXAS INST.  ,
                   TOP  => 'TP',  # TOPCON  ,
                   TPS  => 'TP',  # TOPCON  ,
                   TRI  => 'TR',  # TRIMBLE  ,
                   TRM  => 'TR',  # TRIMBLE  ,
                   TWI  => 'TW',  # Tallysman Wireless Inc.
);
                      
our %goa_dome = (     AUST => 'AU', 
                      BEVA => 'BE',                                         
                      CAFG => 'CA',                                         
		      CHCD => 'CH',
                      CONE => 'CN',                                         
                      DOME => 'DO',
                      DUTD => 'DU',
                      EMRA => 'EM',
                      ENCL => 'EN',
		      HGGC => 'HG',
		      HXCS => 'HX',
                      JAVC => 'JC',
                      JPLA => 'JP',
                      JVDM => 'JV',
		      JVGR => 'JG',
                      LEIC => 'LC',
		      LEIM => 'LM',
                      LEIS => 'LS',
                      LEIT => 'LT',
                      MMAC => 'MM',
                      NONE => '__',
                      NOVC => 'NC',
                      NOVS => 'NS',
                      OLGA => 'OL',
                      OSOD => 'OS',
                      PFAN => 'PF',
                      RPTR => 'RP',
					  RADM => 'RD',
                      SCIS => 'SS',
                      SCIT => 'ST',
                      SCPL => 'SP',
                      SNOW => 'SW',
                      SPKE => 'SK',
                      TCWD => 'TC',
                      TPSD => 'TP',
                      TPSH => 'TS',
                      TZGD => 'TZ',
                      UNAV => 'UN',
                      UNKN => 'UK',
					 '    ' => '__',
				 );

sub new {
  my $class = shift;
  my $file = shift || "$ENV{GPS_HOME_DIR}/igs_info/rcvr_ant.tab";
  my $self =  {};
  bless $self,$class;
  $self->load($file);
  return $self
}

sub goa_dome {
  my $self = shift;
  my $dome = uc shift || '';
  if ( $dome ) {
     $dome =~ s/(x|\s)*//g;
     return $goa_dome{$dome};
  }
  else {
    my @domes = sort values %goa_dome;
    return wantarray ? @domes : \@domes
  }
}


sub vendor_names {
   
}

sub domes {
  my $self = shift;
  return $self->list("domes");
}
sub antennae {
  my $self = shift;
  return $self->list("antennae");
}
sub receivers {
  my $self = shift;
  return $self->list("receivers");
}
sub list {
  my $self = shift;
  my $device = shift || die "Error No device supplied. ex: domes|receivers|antennae\n";
  my @list = sort keys %{$self->{$device}};
  return wantarray ? @list : \@list
}

sub load {
  my $self = shift;
  my $file = shift;
open(my $fh,'<',$file ) or die "Couldnt' open $file $!\n";
my $flag = 0;
my ($l,$r,@l,@r,$maker,$device,$prev_valid,@codes,%seen,$abbreviations);
  $self->{file} = $file;
while( <$fh> ) {
  chomp;
  s/^\s+//;
  s/\s+$//;
  next unless length;
  if  ( /^\|(.{22})\|(.{55})(\||)/ ) {
	  push @l, $1 ;  
	  push @r, $2 ;
	  next;
  }
  elsif ( /\+-+\+-+(\+|)/ ) { 
    
    #next if ! @l && ! @r ;
    if ( ( grep { /abbreviations/i } @l ) && (grep { /description/i } @r) ) {
		$abbreviations=1;
	}
    if ( ( grep { /(previously valid)/i } @l ) && (grep { /new codes/i } @r) ) {
		$prev_valid=1;
	}
	elsif ( (grep { /igs codes/i } @l) && (grep { /description/i } @r) ) {
		$prev_valid = 0;
		$maker = '';
		my $dev = join ' ',@l;
		if ( $dev =~ /(.*?) (receivers|rcvrs|antenna domes|antennae)/i ) {
			$maker = trim(uc $1);
			$device = lc $2; 
		}

        if ( ! trim($maker) && $device eq 'antenna domes' ) {
		   $maker = 'DOMES';
		}
		$device = $device eq 'rcvrs'          ? 'receivers' :
		          $device eq 'antenna domes'  ? 'domes'     :
				  $device;
       @l=(); 
	   @r=();
	}
	else { 
	  my $igs_code ='';
	  my $old_code ='';
	  my $goa_code ='';
      next if $abbreviations;
	  for my $i ( 0 .. $#l ) {
		  $l=unpack('x1a20',$l[$i]);
		  $r=$r[$i];
		  if ( ! trim($l) && ! trim($r) ) {
		    next;
          }  
          elsif ( trim($l) && trim($r) ) {
		     if ( $prev_valid ) {
               @codes =  split(/\s\|\s/,$r);
			   $old_code=$l;
			   foreach my $c ( @codes ) {
				 next if ! trim($c);
			     my $code = sprintf("%-20s",trim($c));
			     $self->{$device}{$code}{maker}=$maker;
			     $self->{$device}{$code}{old_code}{$old_code}=$code;
				 foreach my $ac ( @codes ) {
					next if $c eq $ac;
			        my $alias = sprintf("%-20s",trim($ac));
			        $self->{$device}{$code}{alias_code}{$alias}=$code;
				 }
			   }
		     }
             else {
		      $igs_code=$l;
			  if ( $device eq 'domes' && $maker eq 'DOMES' ) {
                next if exists $self->{$device}{$igs_code};
			  }
			  $self->{$device}{$igs_code}{maker}=$maker;
			  $self->{$device}{$igs_code}{old_code}={};
			  $self->{$device}{$igs_code}{alias_code}={};
              %seen=();
              my @description=@{$self->{$device}{$igs_code}{description}};
              @seen{@description}=(1)x@description;
              if ( ! exists $seen{$r} ) {
                push @{$self->{$device}{$igs_code}{description}},$r;   
              }
			}
          }
		  elsif ( ! trim($l) && trim($r) ) {
		     if ( $prev_valid ) {
               push @codes , split(/\s\|\s/,$r);
			   foreach my $c ( @codes ) {
				 next if ! trim($c);
			     my $code = sprintf("%-20s",trim($c));
			     $self->{$device}{$code}{maker}=$maker;
			     $self->{$device}{$code}{old_code}{$old_code}=$code;
				 foreach my $ac (@codes ) {
			        my $alias = sprintf("%-20s",trim($ac));
					next if $c eq $ac;
			        $self->{$device}{$code}{alias_code}{$alias}=$code;
				 }
			   }
		     }
             else {
			  next if ! $igs_code;
              #push @{$self->{$device}{$igs_code}{description}},$r;   
              %seen=();
              my @description=@{$self->{$device}{$igs_code}{description}};
              @seen{@description}=(1)x@description;
              if ( ! exists $seen{$r} ) {
                push @{$self->{$device}{$igs_code}{description}},$r;   
              }
			 }
		  }
       }
       @l=(); 
	   @r=();
	 }
     @l=(); 
	 @r=();
	 next;
   }

 }
}

sub get_vendor {
   my $self = shift;
   my $igs = shift;
   $igs = ' 'x16 . 'NONE' ? 'NONE'.' 'x12 . 'NONE' : $igs;
   my $c = unpack('a3',$igs);
   if ( $igs =~ /(BLOCK I.* |GLONASS)/ ) {
      return $1
   }
   elsif ( $igs =~ /^NONE/ ) {
      return 'Antenna'
   }
   elsif ( ! exists $goa_vendor{$c} ) {
      die "Unknown IGS vendor code:$c from $igs \n"; 
   }
   my $maker = $goa_vendor_name{$goa_vendor{$c}};
   return $maker
}

sub goa_name {
  my $self = shift;
  my $igs = shift;
  my $antennae = @_ ? shift : $self->{antennae};
  my ($acode,$dome) = unpack('a15x1a4',$igs);
  my $c = unpack('a3',$acode);
  
  return pack("A9",'ZERO') if  trim($acode) eq 'NONE' || $acode eq ' 'x15;
  
  if (  $igs =~ /(BLOCK I|GLONASS)/ ) {
     if ( $igs =~ /BLOCK (.*?) G(\d\d)/ ) {
	    my $block=$1;
	    my $prn = $2;
		$block =~ s/-//;
        return pack("A9","PRN$prn$block");	   
	 }
	 else {
	   return pack("A9",$igs)
	 }
  }
  if (  ! exists $goa_vendor{$c} ) {
    die "No vendor defined for code:$c ($igs)\n";
  }
  if (  ! exists $goa_dome{$dome} ) {
    die "No dome defined for code:$dome ($igs)\n";
  }
  my $gv = $goa_vendor{$c};
  my $gd = $goa_dome{$dome};
  my $m = $acode;
  $m =~ s/^...//;
  $m = unpack('a5',$m);
  $m = trim(fix_str($m));
  my $goa_name = "$gv$m$gd";
  my $ct = 'A';
  my @gn = map { $antennae->{$_}{goa_name} } keys %{$antennae};
  while ( grep /$goa_name/ , @gn ) {
     $m =~ s/\w$/$ct/;
	 $ct++;
     $goa_name = "$gv$m$gd";
  }
  return pack('A9',uc $goa_name);
}

sub fix_str {
  my $s = shift;
  $s =~ s/\s+//g;
  $s =~ s/\//_/g;
  $s =~ s/(\.|\+|\-)//g;
  return $s
}

1;
