package GPS::StrUtil;
use Carp;
use Exporter;

@ISA=('Exporter');
@EXPORT = qw/ trim
              escape
              unescape
	      rm_comment
	      spack
            /; 
sub escape {
   my $s = shift;
   $s =~ s/([^a-zA-Z0-9_ ])/\\$1/g;
   return $s
}	    
sub unescape {
   my $s = shift;
   $s =~ s/\\//g;
   return $s
}
sub trim2 {
    my @out = @_ ? @_ : $_;
    $_ = join(' ', split(' ')) for @out;
    return wantarray ? @out : "@out";
}    
sub rm_comment {
   my $s = shift;
   my %opt = (
     start_comment => '#',
     @_,
   );
   $opt{start_comment}=escape($opt{start_comment});
   $s =~ s/$opt{start_comment}.*//;
   return $s
}

sub spack {
   my %opt = (
      null => ' ',
      @_,
   );
   my $null = $opt{null};
   delete $opt{null};
   my $fmt = shift; 
   my $s = pack($fmt,@_);
   $s=~ s/\0/$null/g; 
   return $s 
}

sub trim {
   my $s = shift;
   $s =~ s/^\s+// ;
   $s =~ s/\s+$// ;
   return $s;
}

1;
